#include <stdio.h>
#include "stack.h"

void print_stack(struct entry *stack);
void print_menu();

int main(void) {
	struct entry *stack = NULL;
	int value;
	char c;

	do{
		print_menu();
		scanf(" %c", &c);

		if (c == 't')
			printf("\n\nElemento in cima allo stack: %i\n\n", top(stack));
		else if (c == '-') {
			stack = pop( stack );
			print_stack( stack );
		} 
		else if (c == '+') {
			printf("Valore da inserire: ");
			scanf("%i", &value);
			stack = push(stack, value);
			print_stack(stack);
		}
	} while (c != 'q'); 
	return 0;
}

/**
 * Funzione che stampa le operazioni disponibili.
 */
void print_menu(){
	printf("Operazioni diponibili:\n");
	printf("+: aggiunta di un elemento\n");
	printf("-: rimozione di un elemento\n");
	printf("t: visualizzazione elemento in cima\n");
	printf("q: uscire\n\n");
	printf("Opzione desiderata: ");
}

/**
 * Funzione che stampa il contenuto di uno stack.
 */
void print_stack(struct entry *stack) {
	struct entry *pointer = stack;

	printf("\n\nElementi nello stack: ");
	while (pointer != NULL) {
		printf("%i ", pointer->value);
		pointer = pointer->next_value;
	}
	printf("\n\n");
}
